import processing.serial.*;
import controlP5.*;

ControlP5 CSS;
ControlP5 CSR;
ControlP5 TXTS;
ControlP5 MSSG;
ControlP5 TXTR;
ControlP5 SND;
ControlP5 DEF;
ControlP5 UPD;
ControlP5 _001U;
ControlP5 _001D;
ControlP5 _01U;
ControlP5 _01D;
ControlP5 _1U;
ControlP5 _1D;
ControlP5 _10U;
ControlP5 _10D;
ControlP5 _100U;
ControlP5 _100D;

Textarea SendText;
Textarea ReceiveText;

Serial Waffle;

String css = "";
String csr = "";
String css_ =  "";
String csr_ = "";
String Mssg = "";
String Mssg_ = "";
String MssgS = "";
String MssgR = "";

boolean Error1 = false;

int freq = 43392;
float freq_;

void setup() 
{
  size(875, 330);
  PFont font = createFont("helvetica", 15);

  printArray(Serial.list());
  String portName = Serial.list()[7];
  Waffle = new Serial(this, portName, 115200);

  CSS = new ControlP5(this);

  CSS.addTextfield("Your callsign")
    .setPosition(50, 50)
    .setSize(125, 25)
    .setFont(font)
    .setFocus(false)
    ;

  CSR = new ControlP5(this);

  CSR.addTextfield("Recipient callsign")
    .setPosition(50, 110)
    .setSize(125, 25)
    .setFont(font)
    .setFocus(false)
    ;

  TXTS = new ControlP5(this);

  TXTS.addTextfield("Text to send")
    .setPosition(327, 50)
    .setSize(125, 86)
    .setFont(font)
    .setFocus(false)
    ;

  MSSG = new ControlP5(this);

  SendText = MSSG.addTextarea("txt")
    .setPosition(50, 180)
    .setSize(775, 30)
    .setFont(font)
    .setLineHeight(14)
    .setColor(color(255))
    .setColorBackground(color(255, 100))
    .setColorForeground(color(255, 100));
  ;

  TXTR = new ControlP5(this);

  ReceiveText = TXTR.addTextarea("txt")
    .setPosition(50, 220)
    .setSize(775, 60)
    .setFont(font)
    .setLineHeight(14)
    .setColor(color(255))
    .setColorBackground(color(255, 100))
    .setColorForeground(color(255, 100));
  ;

  SND = new ControlP5(this);

  SND.addButton("Send")
    .setValue('S')
    .setPosition(467, 50)
    .setSize(133, 86)
    .setFont(font);
  ;
  
  DEF = new ControlP5(this);

  DEF.addButton("DEF")
    .setValue('D')
    .setPosition(615, 50)
    .setSize(35, 25)
    .setFont(font);
  ;
  
  UPD = new ControlP5(this);

  UPD.addButton("UPD")
    .setValue('F')
    .setPosition(775, 50)
    .setSize(35, 25)
    .setFont(font);
  ;

  _100U = new ControlP5(this);

  _100U.addButton("U100")
    .setValue(10000)
    .setPosition(615, 80)
    .setSize(35, 25)
    .setFont(font);
  ;

  _100D = new ControlP5(this);

  _100D.addButton("D100")
    .setValue(-10000)
    .setPosition(615, 110)
    .setSize(35, 25)
    .setFont(font);
  ;

  _10U = new ControlP5(this);

  _10U.addButton("U10")
    .setValue(1000)
    .setPosition(655, 80)
    .setSize(35, 25)
    .setFont(font);
  ;

  _10D = new ControlP5(this);

  _10D.addButton("D10")
    .setValue(-1000)
    .setPosition(655, 110)
    .setSize(35, 25)
    .setFont(font);
  ;

  _1U = new ControlP5(this);

  _1U.addButton("U1")
    .setValue(100)
    .setPosition(695, 80)
    .setSize(35, 25)
    .setFont(font);
  ;

  _1D = new ControlP5(this);

  _1D.addButton("D1")
    .setValue(-100)
    .setPosition(695, 110)
    .setSize(35, 25)
    .setFont(font);
  ;

  _01U = new ControlP5(this);

  _01U.addButton("U_1")
    .setValue(10)
    .setPosition(735, 80)
    .setSize(35, 25)
    .setFont(font);
  ;

  _01D = new ControlP5(this);

  _01D.addButton("D_1")
    .setValue(-10)
    .setPosition(735, 110)
    .setSize(35, 25)
    .setFont(font);
  ;

  _001U = new ControlP5(this);

  _001U.addButton("U_01")
    .setValue(1)
    .setPosition(775, 80)
    .setSize(35, 25)
    .setFont(font);
  ;

  _001D = new ControlP5(this);

  _001D.addButton("D_01")
    .setValue(-1)
    .setPosition(775, 110)
    .setSize(35, 25)
    .setFont(font);
  ;

  textFont(font);
}

void controlEvent(ControlEvent theEvent) 
{
  if (theEvent.isAssignableFrom(Textfield.class)) 
  {
    println("controlEvent: accessing a string from controller '"
      +theEvent.getName()+"': "
      +theEvent.getStringValue()
      );
  }

  if (theEvent.getName() == "Your callsign")
  {
    css = theEvent.getStringValue();
    SetCSS();
  } else if (theEvent.getName() == "Recipient callsign")
  {
    csr = theEvent.getStringValue();
    SetCSR();
  } else if (theEvent.getName() == "Text to send")
  {
    Mssg = theEvent.getStringValue();
    SetMssg();
  }

  SetString();
}

void draw() 
{
  background(0x1d3637);
  fill(255);
  rect(188, 50, 125, 25);
  rect(188, 110, 125, 25);
  rect(655, 50, 115, 25);
  fill(0);
  text(css, 190, 68);
  text(csr, 190, 128);
  convert();
  text(freq_+" MHz", 672, 68);
  
  if(Waffle.available() > 0)
  {
    MssgR = Waffle.readString();
    ReceiveText.setText(MssgR);
  }
}


void SetCSS()
{
  int cssLen = css.length();
  css_ = css;
  if (cssLen < 8)
  {
    while (cssLen != 8)
    {
      css_ = css_+"_";
      cssLen = cssLen+1;
      println(css_);
    }
  }
}

void SetCSR()
{
  int csrLen = csr.length();
  csr_ = csr;
  if (csrLen < 8)
  {
    while (csrLen != 8)
    {
      csr_ = csr_+"_";
      csrLen = csrLen+1;
      println(csr_);
    }
  }
}

void SetMssg()
{
  int MssgLen = Mssg.length();
  Mssg_ = Mssg;
  if (MssgLen < 48)
  {
    while (MssgLen != 48)
    {
      Mssg_ = Mssg_+"_";
      MssgLen = MssgLen+1;
      println(Mssg_);
    }
    Error1 = false;
  } else if (MssgLen > 48)
  {
    MssgS = "Error : Your message can be max 48 chars long !!!";
    SendText.setText(MssgS);
    Error1 = true;
  }
}

void SetString()
{
  if (Error1 == false)
  {
    MssgS = css_+csr_+Mssg_;
    SendText.setText(MssgS);
  }
}

public void Send(int theValue)
{
  if (theValue == 'S' && Error1 == false)
  {
    Waffle.write(MssgS);
  }
}

public void DEF(int theValue)
{
  if(theValue == 'D')
  {
    freq = 43392;
  }
}

public void UPD(int theValue)
{
  if(theValue == 'F')
  {
    Waffle.write("%"+freq);
  }
}

public void U100(int theValue) 
{
  freq=freq+theValue;
}

public void D100(int theValue) 
{
  freq=freq+theValue;
}

public void U10(int theValue) 
{
  freq=freq+theValue;
}

public void D10(int theValue) 
{
  freq=freq+theValue;
}

public void U1(int theValue) 
{
  freq=freq+theValue;
}

public void D1(int theValue) 
{
  freq=freq+theValue;
}

public void U_1(int theValue) 
{
  freq=freq+theValue;
}

public void D_1(int theValue) 
{
  freq=freq+theValue;
}

public void U_01(int theValue) 
{
  freq=freq+theValue;
}

public void D_01(int theValue) 
{
  freq=freq+theValue;
}

void convert()
{
  freq_ = float(freq);
  freq_ = freq_/100;
}